SetTitleMatchMode, 2
SetKeyDelay, 0, 0
SetBatchLines, 10ms
#SingleInstance

ForegroundLockTimeoutValue = 200000 ; Prevent script from resetting "prevent applications from stealing focus" setting
SPI_SETFOREGROUNDLOCKTIMEOUT = 8193
SPIF_UPDATEINIFILE = 1
SPIF_SENDCHANGE = 2

DllCall("SystemParametersInfo", "UInt", SPI_SETFOREGROUNDLOCKTIMEOUT, "UInt", 0, "UInt", ForegroundLockTimeoutValue, "UInt", SPIF_UPDATEINIFILE | SPIF_SENDCHANGE)

AlarmTime := 0
AlarmSet := 0

; rudimentary alarm clock.
~ScrollLock::Gosub, OpenClockDialog

OpenClockDialog:
ErrorLevel := 0  ; ErrorLevel is used for allowing cancel on the inputbox
FormatTime, TimeNow, HHmm, HHmm  ; Get the current time
If AlarmSet = 0  ; Check if alarm is set or not. Different input boxes are displayed for each case
 {
  InputBox, AlarmTime, Set Alarm, It's now %TimeNow%.`nWhen should the alarm ring?`n,, 350, 170  ; Ask user when should the alarm ring
  If (ErrorLevel = 0)  ; Errorlevel becomes 1 if cancel/esc on the inputbox
   {
    MsgBox, 0, ALARM!, Alarm is set to %AlarmTime%`nScroll Lock shows that the alarm is set., 5
    AlarmSet := 1
    SetScrollLockState, On  ; Set scroll lock on, to indicate that alarm is active.
    Gosub, WaitForTheAlarmTime  ; this subroutine waits till the alarm time is reached.
    Return
   }
  Else
   {
    SetScrollLockState, Off  ; Set scroll lock off, to indicate that alarm is disabled.
    Return
   }
 }
Else
 {
  RetainedAlarmTime := AlarmTime  ; cancel on the input box clears the variable, so we make a backup
  InputBox, AlarmTime, Set Alarm, It's now %TimeNow%.`nAlarm is already set to %AlarmTime%.`nSet new alarm time or just press Enter/OK to leave it as is.`nJust press Esc/Cancel to disable the alarm.,, 360, 170  ; Tell the user alarm is already set
  If (ErrorLevel = 0)  ; Errorlevel becomes 1 if cancel/esc on the inputbox
  {
   If AlarmTime = 
    {
     AlarmTime := RetainedAlarmTime  ; Now that the input box is left blank, we cash in on the backup.
     AlarmSet := 1
     SetScrollLockState, On  ; Set scroll lock on, to indicate that alarm is active.
     Gosub, WaitForTheAlarmTime
     Return
    }
   Else
    {
     MsgBox, 0, ALARM!, Alarm is set to %AlarmTime%`nScroll Lock shows that the alarm is set., 5
     AlarmSet := 1
     SetScrollLockState, On  ; Set scroll lock on, to indicate that alarm is active.
     Gosub, WaitForTheAlarmTime
     Return
    }
  }
  Else
   {
    MsgBox, 0, ALARM!, Alarm is disabled., 5
    AlarmSet := 0
    SetScrollLockState, Off  ; Set scroll lock off, to indicate that alarm is disabled.
    Return
   }
 }

WaitForTheAlarmTime:   ; This is the subroutine that actually counts the time, and plays the sound.
While TimeNow <> AlarmTime  ; LEGEN, wait for it...
 {
  FormatTime, TimeNow, HHmm, HHmm
  Sleep, 500  ; if we don't sleep every now and then while loop tires the cpu, if we sleep too much, we lose responsiveness
  If GetKeyState("ScrollLock", "T") = 0  ; Let the user get out of the loop to change or disable alarm.
   {
    SetScrollLockState, On  ; Set scroll lock on, to indicate that alarm is still active.
    Gosub, OpenClockDialog  ; go to the beginning of the clock routine, to allow the user change alarm.
    Return
   }
 }
SoundGet, MasterBeforeMaximize, Master  ; Maximize volume so that alarm really alerts
SoundGet, WaveBeforeMaximize, Wave  ; Don't be rude and get the original volume levels before changing them
SoundSet, 100, Master
SoundSet, 100, Wave
SplashTextOn, 220, 70, ALARM!, Press Scroll Lock to Turn Off`nALARM!
While GetKeyState("ScrollLock", "T") = 1
 SoundPlay, alarm.wav, wait  ; ...DARY!!!
AlarmTime := 0  ; clean up variables
AlarmSet := 0  ; clean up variables
SplashTextOff
SetScrollLockState, Off  ; No need to keep the scroll lock on
SoundSet, %MasterBeforeMaximize%, Master  ; Restore original volume levels
SoundSet, %WaveBeforeMaximize%, Wave
Return
